#include "stdafx.h"
#include "Player.h"


CPlayer::CPlayer()
	: b_isProcessing(false)
	, b_stopConversion(false)
	, b_isFirstFrame(false)
	, b_doBodyTracking(false)
	, b_isDoBodyTrackingChanged(false)
	, b_convertSkeletons(false)
	, b_convertPointcloudColor(false)
	, b_convertPointcloudDepthColor(false)
	, b_convertPngColor(false)
	, b_convertPngColorAligned(false)
	, b_convertPngDepth(false)
	, b_convertPngDepthAligned(false)
	, b_convertPngIr(false)
	, b_convertPngIrAligned(false)
	, b_convertRawColor(false)
	, b_convertRawColorAligned(false)
	, b_convertRawDepth(false)
	, b_convertRawDepthAligned(false)
	, b_convertRawIr(false)
	, b_convertRawIrAligned(false)
{
	m_BaseFilePathAndName.Format(L"");
}


CPlayer::~CPlayer()
{
}


// InitFileNames: process the input filename, create the basename and a vector of names of bags
size_t CPlayer::InitFileNames()
{
	// First inits
	BaseFileName.clear();
	OutputBaseDir.clear();
	if (FileNames.size() > 0)
		FileNames.clear();

	// Check extension
	if (!strstr(RefCamFileName.c_str(), ".mkv"))
		RefCamFileName = RefCamFileName + ".mkv";	

	if (!strstr(RefCamFileName.c_str(), "_MSAzureKinect") && !strstr(RefCamFileName.c_str(), "_SN")) {
		// Generic input files. Only 1 camera expected!
		BaseFileName = RefCamFileName.substr(0, RefCamFileName.length() - 4);
		FileNames.push_back(InputPath + RefCamFileName);
	}
	else {
		// MKV files are generated by this program
		BaseFileName = RefCamFileName.substr(0, RefCamFileName.find("_MSAzureKinect"));
		for (auto& p : std::filesystem::directory_iterator(InputPath))
		{
			std::string tempFileName = p.path().filename().generic_string();
			if (tempFileName.find(BaseFileName) == 0 && tempFileName.find("_MSAzureKinect") == BaseFileName.length()
				&& tempFileName.find("_SN") == BaseFileName.length() + 14 && tempFileName.find(".mkv") != std::string::npos &&
				tempFileName.find("_SN") == tempFileName.length() - 19)
				FileNames.push_back(InputPath + tempFileName);
		}
	}
	if (FileNames.size() == 0) // The file exists, but its name has changed at the last part of the string
		FileNames.push_back(InputPath + RefCamFileName);

	return FileNames.size();
}

void CPlayer::InitPlaybacks()
{
	int nPlaybacks = VirtualKinects.Open(FileNames);

	if (nPlaybacks > 0) {
		// Open image window
		Display.nImageMax = (int)(2 * nPlaybacks);
		Display.Init(nPlaybacks == 1 && b_doBodyTracking);

		nFramesMin = INT_MAX;
		std::vector<int> PlayerDurations = VirtualKinects.GetPlayerDurations();
		for (int i = 0; i < nPlaybacks; i++) {
			if (PlayerDurations[i] < nFramesMin)
				nFramesMin = PlayerDurations[i];
		}
		m_framePos = 0;
		VirtualKinects.GetSerialNumbers(SerialNumbers);
	}
}


void CPlayer::ClosePlaybacks(bool withBodyTracking)
{	
	m_framePos = 0;
	nFramesMin = INT_MAX;
	m_BaseFilePathAndName.Format(L"");
	FileNames.clear();
	InputPath.clear();
	RefCamFileName.clear();
	BaseFileName.clear();
	OutputBaseDir.clear();
	SerialNumbers.clear();
	
	Display.Close(withBodyTracking);
	VirtualKinects.Close();
}


void CPlayer::DisplayFramesAt(int i)
{
	b_isProcessing = true;

	if (b_isFirstFrame) {
		b_isDoBodyTrackingChanged = false;
		b_isFirstFrame = false;
	}

	if (b_isDoBodyTrackingChanged) {
		Display.ReInit(VirtualKinects.Count() == 1 && b_doBodyTracking);
		b_isDoBodyTrackingChanged = false;
	}

	size_t nCaptures = VirtualKinects.GetCaptures(i);
	VirtualKinects.GetIMUSamples(i);

	if (nCaptures > 0) {

		if (VirtualKinects.Count() == 1 && b_doBodyTracking)
			VirtualKinects.DoBodyTracking();

		// Retrieve and assign data
		VirtualKinects.GetImages(Display.Colors, AK::COLOR);
		VirtualKinects.GetImages(Display.IRs, AK::IR);
		VirtualKinects.GetImages(Display.Depths, AK::DEPTH);
		//VirtualKinects.GetImages(Display.DepthsA, AK::DEPTHA);

		if (VirtualKinects.Count() == 1 && b_doBodyTracking) {
			VirtualKinects.GetBodyIndexMaps(Display.BodyIndexMapsA, AK::BODYINDEXMAPA);
			VirtualKinects.GetBodyIDs(Display.BodyIDs);
			VirtualKinects.GetSkeletons(Display.Skeletons);
		}
		VirtualKinects.GetIMUs(Display.IMUs);

		Display.SendImuDataToDlg();
		Display.ShowCaptures();
		if (VirtualKinects.Count() == 1 && b_doBodyTracking)
			Display.ShowBodyTracking();
		Display.ClearVariables();

	}
	

	m_framePos = i;

	VirtualKinects.ReleaseIMUSamples();
	VirtualKinects.ReleaseCaptures();
	VirtualKinects.ReleaseBodyFrames();

	b_isProcessing = false;
}

size_t CPlayer::InitConverters(const std::string currDateTime)
{
	Converters.clear();
	OutputBaseDir = InputPath + BaseFileName + "_" + currDateTime;
	if (b_convertSkeletons)
		AddConverter(CONVERT_SKELETONS);
	if (b_convertPngColor)
		AddConverter(CONVERT_PNG_COLOR);
	if (b_convertPngColorAligned)
		AddConverter(CONVERT_PNG_COLOR_ALIGNED);
	if (b_convertPngDepth)
		AddConverter(CONVERT_PNG_DEPTH);
	if (b_convertPngDepthAligned)
		AddConverter(CONVERT_PNG_DEPTH_ALIGNED);
	if (b_convertPngIr)
		AddConverter(CONVERT_PNG_IR);
	if (b_convertPngIrAligned)
		AddConverter(CONVERT_PNG_IR_ALIGNED);
	if (b_convertRawColor)
		AddConverter(CONVERT_RAW_COLOR);
	if (b_convertRawColorAligned)
		AddConverter(CONVERT_RAW_COLOR_ALIGNED);
	if (b_convertRawDepth)
		AddConverter(CONVERT_RAW_DEPTH);
	if (b_convertRawDepthAligned)
		AddConverter(CONVERT_RAW_DEPTH_ALIGNED);
	if (b_convertRawIr)
		AddConverter(CONVERT_RAW_IR);
	if (b_convertRawIrAligned)
		AddConverter(CONVERT_RAW_IR_ALIGNED);
	if (b_convertPointcloudColor)
		AddConverter(CONVERT_POINTCLOUDSCOLOR);
	if (b_convertPointcloudDepthColor)
		AddConverter(CONVERT_POINTCLOUDSDEPTH);
	return Converters.size();
}


void CPlayer::AddConverter(conversion_type inputConversion)
{
	for (int idx = 0; idx < VirtualKinects.Count(); idx++) {
		std::string subDirectory;
		
		if (inputConversion == CONVERT_PNG_COLOR)
			subDirectory = OutputBaseDir + "/Color/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_PNG_COLOR_ALIGNED)
			subDirectory = OutputBaseDir + "/ColorAligned/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_PNG_DEPTH)
			subDirectory = OutputBaseDir + "/Depth/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_PNG_DEPTH_ALIGNED)
			subDirectory = OutputBaseDir + "/DepthAligned/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_PNG_IR)
			subDirectory = OutputBaseDir + "/Infrared/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_PNG_IR_ALIGNED)
			subDirectory = OutputBaseDir + "/InfraredAligned/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_RAW_COLOR)
			subDirectory = OutputBaseDir + "/ColorRaw/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_RAW_COLOR_ALIGNED)
			subDirectory = OutputBaseDir + "/ColorRawAligned/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_RAW_DEPTH)
			subDirectory = OutputBaseDir + "/DepthRaw/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_RAW_DEPTH_ALIGNED)
			subDirectory = OutputBaseDir + "/DepthRawAligned/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_RAW_IR)
			subDirectory = OutputBaseDir + "/InfraredRaw/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_RAW_IR_ALIGNED)
			subDirectory = OutputBaseDir + "/InfraredRawAligned/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_POINTCLOUDSCOLOR) 
			subDirectory = OutputBaseDir + "/PointClouds_ColorGeometry/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_POINTCLOUDSDEPTH)
			subDirectory = OutputBaseDir + "/PointClouds_DepthGeometry/" + SerialNumbers[idx];
		else if (inputConversion == CONVERT_SKELETONS)
			subDirectory = OutputBaseDir + "/Skeletons/" + SerialNumbers[idx];
		
		std::shared_ptr<CConverter> tConverter;
		tConverter = std::make_shared<CConverter>();
		tConverter->SetConverter(inputConversion, subDirectory, idx);
		Converters.push_back(tConverter);
	}
}


bool CPlayer::CheckConversion(conversion_type inputConversion)
{
	for (int i = 0; i < Converters.size(); i++) {
		if (Converters[i]->GetConversionType() == inputConversion)
			return true;
	}
	return false;
}


void CPlayer::ConvertFramesAt(int pos)
{
	std::vector<AK::SSkeleton> allSkeletons;
	std::vector<std::vector<AK::SSkeleton>> perKinectSkeletons;
	std::vector<AK::SPointcloud> tPointcloudsColor, tPointcloudsDepth;
	std::vector<AK::SImage> tColors, tColorsA, tDepths, tDepthsA, tIrs, tIrsA;

	size_t nCaptures = VirtualKinects.GetCaptures(pos);
	
	if (nCaptures > 0) {
		
		if (CheckConversion(CONVERT_PNG_COLOR) || CheckConversion(CONVERT_RAW_COLOR)) {
			VirtualKinects.GetImages(tColors, AK::COLOR);
		}
		if (CheckConversion(CONVERT_PNG_COLOR_ALIGNED) || CheckConversion(CONVERT_RAW_COLOR_ALIGNED)) {
			VirtualKinects.GetImages(tColorsA, AK::COLORA);
			if (tDepths.size() == 0)
				VirtualKinects.GetImages(tDepths, AK::DEPTH);
		}
		if (CheckConversion(CONVERT_PNG_DEPTH) || CheckConversion(CONVERT_RAW_DEPTH)) {
			if (tDepths.size() == 0)
				VirtualKinects.GetImages(tDepths, AK::DEPTH);
		}
		if (CheckConversion(CONVERT_PNG_DEPTH_ALIGNED) || CheckConversion(CONVERT_RAW_DEPTH_ALIGNED)) {
			VirtualKinects.GetImages(tDepthsA, AK::DEPTHA);
		}
		if (CheckConversion(CONVERT_PNG_IR) || CheckConversion(CONVERT_RAW_IR)) {
			VirtualKinects.GetImages(tIrs, AK::IR);
		}
		if (CheckConversion(CONVERT_PNG_IR_ALIGNED) || CheckConversion(CONVERT_RAW_IR_ALIGNED)) {
			VirtualKinects.GetImages(tIrsA, AK::IRA);
		}
		if (CheckConversion(CONVERT_POINTCLOUDSCOLOR)) {
			VirtualKinects.GetPointcloudsOnColorGeometry(tPointcloudsColor);
		}
		if (CheckConversion(CONVERT_POINTCLOUDSDEPTH)) {
			VirtualKinects.GetPointcloudsOnDepthGeometry(tPointcloudsDepth);
		}
		if (CheckConversion(CONVERT_SKELETONS)) {
			VirtualKinects.DoBodyTracking();
			VirtualKinects.GetSkeletons(allSkeletons);
		}

		VirtualKinects.AssignSkeletonsToParentKinect(allSkeletons, perKinectSkeletons);

		std::vector<bool> isAKWorking;
		VirtualKinects.GetValidKinects(isAKWorking);
		std::vector<int> idxAKWorking;
		int KinectCount = 0;
		for (int i = 0; i < VirtualKinects.Count(); i++) {
			idxAKWorking.push_back(KinectCount);
			if (isAKWorking[i])
				KinectCount++;
		}

		// Setup threads
		for (int i = 0; i < Converters.size(); i++) {
			if (isAKWorking[Converters[i]->GetReferenceKinect()]) {

				if (Converters[i]->GetConversionType() == CONVERT_PNG_COLOR || Converters[i]->GetConversionType() == CONVERT_RAW_COLOR)
					Converters[i]->SetImage(tColors[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_COLOR_ALIGNED || Converters[i]->GetConversionType() == CONVERT_RAW_COLOR_ALIGNED) {
					Converters[i]->SetImage(tColorsA[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
					Converters[i]->SetSupportImage(tDepths[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				}			
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_DEPTH || Converters[i]->GetConversionType() == CONVERT_RAW_DEPTH)
					Converters[i]->SetImage(tDepths[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_DEPTH_ALIGNED || Converters[i]->GetConversionType() == CONVERT_RAW_DEPTH_ALIGNED)
					Converters[i]->SetImage(tDepthsA[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_IR || Converters[i]->GetConversionType() == CONVERT_RAW_IR)
					Converters[i]->SetImage(tIrs[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_IR_ALIGNED || Converters[i]->GetConversionType() == CONVERT_RAW_IR_ALIGNED)
					Converters[i]->SetImage(tIrsA[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				else if (Converters[i]->GetConversionType() == CONVERT_POINTCLOUDSCOLOR)
					Converters[i]->SetPointcloud(tPointcloudsColor[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				else if (Converters[i]->GetConversionType() == CONVERT_POINTCLOUDSDEPTH)
					Converters[i]->SetPointcloud(tPointcloudsDepth[idxAKWorking[Converters[i]->GetReferenceKinect()]]);
				else if (Converters[i]->GetConversionType() == CONVERT_SKELETONS)
					Converters[i]->SetSkeletons(perKinectSkeletons[idxAKWorking[Converters[i]->GetReferenceKinect()]]); //Converters[i]->SetSkeletons(perKinectSkeletons[Converters[i]->GetReferenceKinect()]);

				Converters[i]->SetFrameID(pos);
				Converters[i]->SetSerialNumber(SerialNumbers[Converters[i]->GetReferenceKinect()]);
				Converters[i]->StartConversionThreads();
			}	
		}

		// Run threads
		for (int i = 0; i < Converters.size(); i++) {
			if (isAKWorking[Converters[i]->GetReferenceKinect()]) {
				CString tString;
				std::string tStrSerial, tStr;
				Converters[i]->GetSerialNumber(tStrSerial);
				if (Converters[i]->GetConversionType() == CONVERT_PNG_COLOR)
					tStr = "Convert color image to png format";
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_COLOR_ALIGNED)
					tStr = "Convert aligned color image to png format";
				else if (Converters[i]->GetConversionType() == CONVERT_RAW_COLOR)
					tStr = "Convert color image to raw format";
				else if (Converters[i]->GetConversionType() == CONVERT_RAW_COLOR_ALIGNED)
					tStr = "Convert aligned color image to raw format";
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_DEPTH)
					tStr = "Convert depth image to png format";
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_DEPTH_ALIGNED)
					tStr = "Convert aligned depth image to png format";
				else if (Converters[i]->GetConversionType() == CONVERT_RAW_DEPTH)
					tStr = "Convert depth image to raw format";
				else if (Converters[i]->GetConversionType() == CONVERT_RAW_DEPTH_ALIGNED)
					tStr = "Convert aligned depth image to raw format";
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_IR)
					tStr = "Convert infrared image to png format";
				else if (Converters[i]->GetConversionType() == CONVERT_PNG_IR_ALIGNED)
					tStr = "Convert aligned infrared image to png format";
				else if (Converters[i]->GetConversionType() == CONVERT_RAW_IR) 
					tStr = "Convert infrared image to raw format";
				else if (Converters[i]->GetConversionType() == CONVERT_RAW_IR_ALIGNED) 
					tStr = "Convert aligned infrared image to raw format";
				else if (Converters[i]->GetConversionType() == CONVERT_SKELETONS) 
					tStr = "Convert skeleton data";
				else if (Converters[i]->GetConversionType() == CONVERT_POINTCLOUDSCOLOR) 
					tStr = "Convert pointcloud (color geometry)";
				else if (Converters[i]->GetConversionType() == CONVERT_POINTCLOUDSDEPTH) 
					tStr = "Convert pointcloud (depth geometry)";
		
				tString.Format(L"Frame %d: %s (virtual Azure Kinect %d, S/N %s)\r\n", pos, VirtualKinects.GetWChar(tStr.c_str()), Converters[i]->GetReferenceKinect(), VirtualKinects.GetWChar(tStrSerial.c_str()));
				VirtualKinects.AppendLogMessages(tString);
		
				Converters[i]->EndConversionThreads();
			}
		}	
	}	

	VirtualKinects.ReleaseCaptures();
	VirtualKinects.ReleaseBodyFrames();
}
